<template>
  <div
    ref="reference"
    v-click-outside="onOutsideClick"
    class="ob-address-input-container address-input ob-address-input"
  >
    <ObInput
      ref="input"
      v-model.trim="currentAddress"
      v-debounce:500ms.lock="querySearch"
      :label="title"
      :pre-icon="prefixIcon"
      :placeholder="placeholder"
      :validation-message="isValid ? 'null' : popoverMessage"
      :is-valid="isValid ? null : false"
      :icon="showMap ? 'map' : customIcon ? customIcon : null"
      :disabled="disabled"
      :data-qa="dataQa"
      :is-dirty-force="true"
      :required="required"
      :is-clear="isClear"
      @on-click-icon="
        showMap ? viewCenterMap() : customAction ? $emit('customAction') : null
      "
      @focus="focusHandler"
      @clear="onClearInput"
      @keydown.up.native.prevent="highlightPrev"
      @keydown.down.native.prevent="highlightNext"
      @keydown.enter.native="selectResult"
      @keydown.native.esc="onEscape"
    />
    <select-dropdown
      ref="popper"
      v-model="opened"
      position="bottom-start"
    >
      <div
        v-if="(list.length && opened) || isLoading"
        ref="results"
        class="ob-address-input__results"
      >
        <div
          v-for="(item, index) in list"
          :key="index"
          :class="[
            'ob-address-input__results-item',
            highlightedIndex === index ? 'highlighted' : '',
          ]"
          :data-qa="dataQa"
          @click.stop.prevent="onSelect(item)"
        >
          <div class="ob-address-input__item-info">
            <i
              v-if="item.icon"
              :class="['icon', item.icon]"
            />
            <div class="ob-address-input__item-address">
              <div v-html="highlightSearch(item.label)" />
              <span v-if="item.locationTitle">{{ item.locationTitle }}</span>
            </div>
          </div>
        </div>
        <transition name="fadeIn">
          <div
            v-if="isLoading"
            class="loading-block"
          >
            <ObLoader :size="35" />
          </div>
        </transition>
      </div>
    </select-dropdown>
    <obAddressModal
      ref="modalMap"
      v-model="activeMapAddress"
      :mobile-title="title"
      :is-mobile="isMobile"
      :map-id="mapId"
      :data-qa="dataQa"
      :display-exp="displayExp"
      @input="onChangeModalAddress"
    />
  </div>
</template>

<script>
import Vue from 'vue'
import ClickOutside from 'vue-click-outside'
import vueDebounce from 'vue-debounce'
import api from '@/api'
import obAddressModal from 'common-components/src/obComponents/obAddressModal'
import ObInput from 'common-components/src/obComponents/obInput'
import SelectDropdown from 'common-components/src/obComponents/obSelect/select-dropdown'
import ObLoader from 'common-components/src/obComponents/obLoader'

Vue.use(vueDebounce)

export default {
  name: 'ObAddressInput',
  components: {
    obAddressModal,
    ObInput,
    SelectDropdown,
    ObLoader
  },
  directives: {
    ClickOutside
  },
  provide () {
    return {
      select: this
    }
  },
  locationTypes: {
    'жд станция': 'train-sm',
    'аэропорт': 'airplane-sm',
    'контейнерный терминал': 'container-sm',
    'морской порт': 'ship-sm',
    'опорная точка': 'city-sm',
    'пограничный переход': 'restrict-sm',
    'пункт таможенного оформления/свх': 'police-sm'
  },

  props: {
    isLocations: {
      type: Boolean,
      default: false
    },
    isMobile: {
      type: Boolean,
      default: false
    },
    address: {
      type: String
    },

    mapAddress: {
      type: Object,
      default: () => {}
    },

    showMap: {
      type: Boolean,
      default: true
    },

    customIcon: {
      type: String
    },

    customAction: {
      type: Boolean,
      default: false
    },

    disabled: {
      type: Boolean,
      default: false
    },

    placeholder: {
      type: String,
      default: 'Адрес или точка на карте'
    },

    title: {
      type: String
    },

    mapId: {
      type: String
    },

    isValid: {
      type: Boolean,
      default: true
    },

    popoverMessage: {
      type: String
    },

    locationsTypes: {
      type: Array
    },

    prefixIcon: {
      type: String
    },

    isLocationsOnly: {
      type: Boolean,
      default: false
    },

    isAddressOnly: {
      type: Boolean,
      default: false
    },

    isNoLocations: {
      type: Boolean,
      default: false
    },

    required: {
      type: Boolean,
      default: false
    },

    dataQa: {
      type: String
    },

    displayExp: {
      type: String,
      default: 'russianAddress'
    },
    isClear: {
      type: Boolean,
      default: true
    },
  },

  data () {
    return {
      locationsTypesMap: [],
      currentAddress: '',
      backUp: '',
      list: [],
      icon: '',
      activeMapAddress: this.mapAddress,
      opened: false,
      isLoading: false,
      highlightedIndex: 0
    }
  },

  watch: {
    address: {
      handler (newVal) {
        this.setAddress(newVal)
      },
      immediate: true
    },
    mapAddress: {
      handler (newVal) {
        this.setMapAddress(newVal)
      },
      immediate: true
    },
    locationsTypes (newVal) {
      this.locationsTypesMap = newVal
    }
  },

  created () {
    if (!this.locationsTypes) {
      api.locations
        .getLocationTypes()
        .then((res) => {
          this.locationsTypesMap = res.data.content
        })
        .catch((e) => {
          console.error(e)
        })
    } else {
      this.locationsTypesMap = this.locationsTypes
    }
  },

  methods: {
    highlightSearch (string) {
      if (!this.currentAddress) {
        return string
      }
      const words = this.currentAddress.split(' ')
      const arr = string.split(',')

      return arr.map(item => {
        words.forEach(addr => {
          item = item.replace(new RegExp(addr, 'gi'), match => {
            return `<span class="highlightText">${match}</span>`
          })
        })
        return item
      }).join()
    },
    highlightPrev () {
      if (this.$refs.results) {
        if (this.highlightedIndex > 0) {
          this.highlightedIndex -= 1
          this.scrollResults()
        }
      }
    },
    highlightNext () {
      if (this.$refs.results) {
        if (this.highlightedIndex < this.list.length - 1) {
          this.highlightedIndex += 1
          this.scrollResults()
        }
      }
    },
    selectResult () {
      if (this.list[this.highlightedIndex]) {
        this.onSelect(this.list[this.highlightedIndex])
      }
    },
    scrollResults () {
      this.$refs.results.children[this.highlightedIndex].scrollIntoView({
        block: 'nearest'
      })
    },
    onEscape () {
      this.setAddress(this.backUp)
      this.prevSearch = this.currentAddress || ''
      this.highlightedIndex = 0
      this.opened = false
      this.list = []
    },
    setAddress (newVal) {
      this.currentAddress = newVal
      this.backUp = newVal
      this.prevSearch = newVal
    },
    setMapAddress (newVal) {
      this.activeMapAddress = newVal
    },
    async querySearch (queryStr) {
      if (!queryStr || queryStr.length < 3 || this.prevSearch === queryStr) {
        return
      }

      if (!this.opened) {
        this.list = []
      }
      this.opened = true
      this.isLoading = true
      this.prevSearch = queryStr
      const res = await api.geocoder.searchLocationsAddressSuggester({
        search_address: queryStr,
        lang: this.lang
      })

      this.list = res.results.map(item => {
        const {
          // eslint-disable-next-line camelcase
          coordinates,
          russian_address,
          country_code
        } = item;
        return {
          coordinates,
          label: russian_address,
          countryCode: country_code
        }
      });

      this.isLoading = false
      this.highlightedIndex = 0
      this.scrollResults()
    },

    viewCenterMap () {
      if (this.disabled) return
      this.opened = false
      this.onEscape()
      this.$refs.modalMap.open()
    },

    onSelect (address) {
      this.icon = address.icon
      this.setAddress(address.label)
      this.setMapAddress({
        russian_address: address.label,
        coordinates: address.coordinates
      })
      this.opened = false
      this.list = []
      this.$emit('input', address)
      this.$refs.input.onBlurHandler()
    },

    onChangeModalAddress ($event) {
      const newAddress = {
        label: $event.russian_address || $event.russianAddress,
        coordinates: $event.coordinates,
        locationUuid: $event.locationUuid,
        countryCode: $event.countryShortCode
      }
      this.setAddress(newAddress.label)
      this.setMapAddress($event)
      this.$emit('input', newAddress)
    },
    onOutsideClick ($event) {
      let target = $event.target
      let popper = this.$refs.popper.$el
      if (target === popper || popper.contains(target)) {
        return false
      } else {
        this.onEscape()
      }
    },
    focusHandler () {
      if (this.list.length && !this.opened) {
        this.opened = true
      }
    },
    onClearInput () {
      this.icon = null
      this.setAddress('')
      this.setMapAddress({})
      this.$emit('input', '')
    }
  }
}
</script>

<style lang="scss">
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.ob-address-input {
  &__results {
    max-height: 300px;
    min-height: 56px;
    overflow: auto;
    padding: 10px 0;
    font-size: 16px;
    line-height: 22px;
    letter-spacing: 0.2px;
    color: $cobalt-black;
    background-color: white;
    box-shadow: 0 4px 8px rgba($color-blue-navy-blue, 0.25);
    border-radius: 3px;
    &-item {
      display: flex;
      align-items: center;
      padding: 7px 16px;
      cursor: pointer;

      &:hover {
        background-color: $light-lavender;
      }

      .icon {
        position: relative;
        margin-right: 10px;
        font-size: 18px;
        line-height: 1.2;
        color: $color-blue-navy-blue;

        &.container {
          width: auto;
        }
      }
    }

    .loading-block {
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
      height: 100%;
      display: flex;
      justify-content: center;
      align-items: center;
      background-color: $obAddressInput-results_loading_block_background-color;
    }
  }
}

.highlighted {
  background-color: $light-lavender;
}

.ob-address-input__item-info {
  display: flex;
}

.ob-address-input__item-address {
  display: flex;
  flex-direction: column;
  span {
    margin-top: 0.3em;
    @include font-mixin(12px, 14px, 400, $gray-slate);
  }
  span.highlightText {
    @include font-mixin(16px, 22px, 700, $color-blue-smalt);
  }
}
</style>
